// Morten's JavaScript Tree Menu
// written by Morten Wang <morten@treemenu.com> (c) 1998-2000
// This is version 2.2.6, dated 2000-03-30

// The script is freely distributable
// It may be used (and modified) as you wish, but retain this message
// For more information about the menu visit its home page
// http://www.treemenu.com/

/******************************************************************************
* Define the MenuItem object.                                                 *
******************************************************************************/
function MTMenuItem(text, url, target, icon)
{
   this.text = text;
   this.url = url ? url : "";
   this.target =  target ? target : "";
   this.icon = icon ? icon : "";

   this.number = MTMSubNumber++;

   this.submenu     = null;
   this.expanded    = false;
   this.MTMakeSubmenu = MTMakeSubmenu;

   /******************************************************************
   * In MTMEmulateMVP mode we keep up with a Granite folder id
   * and a path to the folder, delimited with unprintable character
   * 16 (we tokenize the path and display it indented)
   ******************************************************************/

   if (MTMEmulateMVP)
   {
      this.id         = null;
      this.MTMSetId   = MTMSetId;

      this.pathname   = null;
      this.MTMSetPath = MTMSetPath;

      this.accessible = true;
      this.MTMSetAccessible = MTMSetAccessible;
   }
}

function MTMakeSubmenu(menu)
{
   this.submenu = menu;
}

/******************************************************************
* The next methods are only used in MTMEmulateMVP mode
******************************************************************/

function MTMSetId(id)
{
   this.id = id;
}

function MTMSetPath(path)
{
   this.pathname = path;
}

function MTMSetAccessible(flag)
{
   this.accessible = flag;
}

/******************************************************************************
* Define the Menu object.                                                     *
******************************************************************************/

function MTMenu()
{
   this.items   = new Array();
   this.MTMAddItem = MTMAddItem;
}

function MTMAddItem(item)
{
   this.items[this.items.length] = item;
}

/******************************************************************************
* Define the icon list, addIcon function and MTMIcon item.                    *
******************************************************************************/

function IconList()
{
   this.items = new Array();
   this.addIcon = addIcon;
}

function addIcon(item)
{
   this.items[this.items.length] = item;
}

function MTMIcon(iconfile, match, type)
{
   this.file = iconfile;
   this.match = match;
   this.type = type;
}

/******************************************************************************
* Global variables.  Not to be altered unless you know what you're doing.     *
* User-configurable options are at the end of this document.                  *
******************************************************************************/

var MTMLoaded = false;
var MTMLevel;
var MTMBar = new Array();
var MTMIndices = new Array();
var MTMBrowser = null;
var MTMNN3 = false;
var MTMNN4 = false;
var MTMIE4 = false;
var MTMUseStyle = true;

if (navigator.appName == "Netscape" && navigator.userAgent.indexOf("WebTV") == -1)
{
   if (parseInt(navigator.appVersion) == 3 && (navigator.userAgent.indexOf("Opera") == -1))
   {
      MTMBrowser = true;
      MTMNN3 = true;
      MTMUseStyle = false;
   }
   else if (parseInt(navigator.appVersion) >= 4)
   {
      MTMBrowser = true;
      MTMNN4 = true;
   }
}
else if (navigator.appName == "Microsoft Internet Explorer" && parseInt(navigator.appVersion) >= 4)
{
   MTMBrowser = true;
   MTMIE4 = true;
}

var MTMClickedItem = false;
var MTMExpansion = false;

var MTMSubNumber = 1;
var MTMTrackedItem = false;
var MTMExpandAllFlag = false;
var MTMCollapseAllFlag = false;

/******************************************************************
* In MTMEmulateMVP mode we keep up with a Granite folder id
* and a path to the folder, delimited with unprintable character
* 16 (we tokenize the path and display it indented)
******************************************************************/

var MTMTrackedId = null;
var MTMTrackedPath = null;

var MTMTrack = false;

var MTMPreHREF = "";
if (MTMIE4 || MTMNN3)
{
   MTMPreHREF += document.location.href.substring(0, document.location.href.lastIndexOf("/") +1);
}

var MTMFirstRun = true;
var MTMCurrentTime = 0; // for checking timeout.
var MTMUpdating = false;
var MTMWinSize, MTMyval;
var MTMOutputString = "";

/******************************************************************************
* Code that picks up frame names of frames in the parent frameset.            *
******************************************************************************/

if (MTMBrowser)
{
   var MTMFrameNames = new Array();
   for (i = 0; i < parent.frames.length; i++)
      MTMFrameNames[i] = parent.frames[i].name;
}

/******************************************************************************
* Dummy function for sub-menus without URLs                                   *
* Thanks to Michel Plungjan for the advice. :)                                *
******************************************************************************/

function myVoid() { ;}

/******************************************************************************
* Functions to draw the menu.                                                 *
******************************************************************************/

function MTMSubAction(SubItem, ReturnValue)
{
   SubItem.expanded = (SubItem.expanded) ? false : true;
   if (SubItem.expanded)
   {
      MTMExpansion = true;
   }

   /******************************************************************
   * In MTMEmulateMVP mode we only call this method when the +/- icon
   * of a folder has been clicked and we don't select the folder.  To
   * select the folder you click the folder icon or text and we call
   * MTMSelectAction(), below.
   ******************************************************************/
   if (!MTMEmulateMVP)
   {
      MTMClickedItem = SubItem.number;

      if (MTMTrackedItem && MTMTrackedItem != SubItem.number)
      {
         MTMTrackedItem = false;
      }
   }

   if (!ReturnValue)
   {
      setTimeout("MTMDisplayMenu()", 10);
   }

   return ReturnValue;
}

/******************************************************************
* In MTMEmulateMVP mode we only call MTMSubAction when the +/- icon
* of a folder has been clicked and we don't select the folder.  To
* select the folder you click the folder icon or text and we call
* this method.
******************************************************************/
function MTMSelectAction(SubItem)
{
   MTMTrackedItem = SubItem.number;

   MTMTrackedId   = SubItem.id;

   MTMTrackedPath = SubItem.pathname;

   // Update the link's color
   setTimeout("MTMDisplayMenu()", 10);

   return true;
}

function MTMExpandAll(expand)
{
   if (expand)
   {
      MTMExpandAllFlag = true;
   }
   else
   {
      MTMCollapseAllFlag = true;
   }

   setTimeout("MTMDisplayMenu()", 10);
}

function MTMStartMenu()
{
   MTMLoaded = true;
   if (MTMFirstRun)
   {
      MTMCurrentTime++;
      if (MTMCurrentTime == MTMTimeOut)
      { // call MTMDisplayMenu
         setTimeout("MTMDisplayMenu()",10);
      }
      else
      {
         setTimeout("MTMStartMenu()",100);
      }
   }
}

function MTMDisplayMenu()
{
   if (MTMBrowser && !MTMUpdating)
   {
      MTMUpdating = true;
      MTMFirstRun = false;

      // Figure out which menu item, if any, corresponds
      // to the content in the "text" frame.
      // In MTMEmulateMVP mode there is no text frame.
      if (MTMTrack && !MTMEmulateMVP)
      {
         MTMTrackedItem = MTMTrackExpand(menu);
      }

      // If we're expanding a submenu and MTMSubsAutoClose is
      // enabled, close all other submenus first
      if (MTMExpansion && MTMSubsAutoClose)
      {
         MTMCloseSubs(menu);
      }

      // Open the menu frame and start writing the menu
      MTMLevel = 0;
      MTMDoc = parent.frames[MTMenuFrame].document
      MTMDoc.open("text/html", "replace");
      MTMOutputString = '<html><head>';

      // Style sheet
      if (MTMLinkedSS)
      {
         MTMOutputString += '<link rel="stylesheet" type="text/css" href="' + MTMPreHREF + MTMSSHREF + '">';
      }
      else if (MTMUseStyle)
      {
         MTMOutputString += '<style type="text/css">body {color:' + MTMTextColor + ';background:';
         MTMOutputString += (MTMBackground == "") ? MTMBGColor : MTMakeBackImage(MTMBackground);
         MTMOutputString += ';} #root {color:' + MTMRootColor + ';background:' + ((MTMBackground == "") ? MTMBGColor : 'transparent') + ';font-family:' + MTMRootFont + ';font-size:' + MTMRootCSSize + '} ';
         MTMOutputString += 'a {font-family:' + MTMenuFont + ';font-size:' + MTMenuCSSize + ';text-decoration:none;color:' + MTMLinkColor + ';background:' + MTMakeBackground() + ';} ';
         if (MTMEmulateMVP)
         {
            // Tracked item gets white text on blue background, no hover color
            MTMOutputString += MTMakeTracked();

            // Inaccessible item gets italicized black text on white background
            MTMOutputString += MTMakeInaccessible();
         }
         else
         {
            MTMOutputString += MTMakeA('pseudo', 'hover', MTMAhoverColor);
            MTMOutputString += MTMakeA('class', 'tracked', MTMTrackColor);
         }
         MTMOutputString += MTMakeA('class', 'subexpanded', MTMSubExpandColor);
         MTMOutputString += MTMakeA('class', 'subclosed', MTMSubClosedColor) + '</style>';
      }

      MTMOutputString += '</head><body ';
      if (MTMBackground != "")
      {
         MTMOutputString += 'background="' + MTMPreHREF + MTMenuImageDirectory + MTMBackground + '" ';
      }
      MTMOutputString += 'bgcolor="' + MTMBGColor + '" text="' + MTMTextColor + '" link="' + MTMLinkColor + '" vlink="' + MTMLinkColor + '" alink="' + MTMLinkColor + '">';

      if (MTMessage != null)
      {
         MTMOutputString += '<font size="4" face="' + MTMenuFont + '" color="blue">' + MTMessage + '</font>';
      }

      MTMOutputString += '<table border="0" cellpadding="0" cellspacing="0" width="' + MTMTableWidth + '">';

      // Root folder
      MTMOutputString += '<tr valign="top"><td nowrap><img src="' + MTMPreHREF + MTMenuImageDirectory + MTMRootIcon + '" align="left" border="0" vspace="0" hspace="0">';
      if (MTMUseStyle)
      {
         MTMOutputString += '<span id="root">&nbsp;' + MTMenuText + '</span>';
      }
      else
      {
         MTMOutputString += '<font size="' + MTMRootFontSize + '" face="' + MTMRootFont + '" color="' + MTMRootColor + '">' + MTMenuText + '</font>';
      }
      MTMDoc.writeln(MTMOutputString + '</td></tr>');

      // Subfolders
      MTMListItems(menu);

      // Finish up

      MTMDoc.writeln('</table></body></html>');
      MTMDoc.close();

      if (MTMEmulateMVP)
      {
         // Make sure any previously-selected item is visible and selected

         if ((MTMTrackedItem) && (MTMNN4 || MTMIE4))
         {
            MTMItemName = "sub" + MTMTrackedItem;

            var anchor = null;

            // Netscape with scrollbars
            if (document.layers && parent.frames[MTMenuFrame].scrollbars)
            {
               anchor = parent.frames[MTMenuFrame].document.anchors[MTMItemName];

               // Make sure it's there - we might have collapsed all
               if (anchor != null)
               {
                  MTMyval = anchor.y;
                  MTMWinSize = parent.frames[MTMenuFrame].innerHeight;
               }
            }

            // IE or no scrollbars
            else
            {
               // Returns a list (there are more than one) of the anchors with this name
               var myAnchors = parent.frames[MTMenuFrame].document.all[MTMItemName];

               // Make sure it's there - we might have collapsed all
               if (myAnchors != null)
               {
                  // Get the first one - they all have the same vertical position
                  var anchor = myAnchors[0];

                  if (anchor != null)
                  {
                     MTMyval = MTMGetPos(anchor);
                     MTMWinSize = parent.frames[MTMenuFrame].document.body.offsetHeight;
                  }
               }
            }

            if (anchor && (MTMyval > (MTMWinSize - 60)))
            {
               parent.frames[MTMenuFrame].scrollBy(0, parseInt(MTMyval - (MTMWinSize * 1/3)));
            }
         }
      }
      else
      {
         // This tries to scroll the clicked item (or the one that's showing
         // up in the text frame) into view
         if ((MTMClickedItem || MTMTrackedItem) && (MTMNN4 || MTMIE4) && !MTMFirstRun)
         {
            MTMItemName = "sub" + (MTMClickedItem ? MTMClickedItem : MTMTrackedItem);
            if (document.layers && parent.frames[MTMenuFrame].scrollbars)
            {
               MTMyval = parent.frames[MTMenuFrame].document.anchors[MTMItemName].y;
               MTMWinSize = parent.frames[MTMenuFrame].innerHeight;
            }
            else
            {
               MTMyval = MTMGetPos(parent.frames[MTMenuFrame].document.all[MTMItemName]);
               MTMWinSize = parent.frames[MTMenuFrame].document.body.offsetHeight;
            }
            if (MTMyval > (MTMWinSize - 60))
            {
               parent.frames[MTMenuFrame].scrollBy(0, parseInt(MTMyval - (MTMWinSize * 1/3)));
            }
         }
      }

      // Reset globals
      MTMClickedItem = false;
      MTMExpansion = false;
      MTMTrack = false;
      MTMExpandAllFlag = false;
      MTMCollapseAllFlag = false;
   }

   MTMUpdating = false;
}

function MTMListItems(menu)
{
   var i, isLast;
   for (i = 0; i < menu.items.length; i++)
   {
      MTMIndices[MTMLevel] = i;
      isLast = (i == menu.items.length -1);

      // If Expand All or Collapse All was pressed, take care of it here.
      if (MTMEmulateMVP)
      {
         if (MTMExpandAllFlag)
         {
            menu.items[i].expanded = true;
         }
         else if (MTMCollapseAllFlag)
         {
            menu.items[i].expanded = false;
         }
      }

      // Display the item
      MTMDisplayItem(menu.items[i], isLast);

      // If it has a submenu and it's expanded...
      if (menu.items[i].submenu && menu.items[i].expanded)
      {
         // If it's not the last item, all of its children will
         // need a vertical bar at the current level
         MTMBar[MTMLevel] = (isLast) ? false : true;

         // We're going a level deeper
         MTMLevel++;

         // Recursively list the submenu items
         MTMListItems(menu.items[i].submenu);

         // Return to our level
         MTMLevel--;
      }
      else
      {
         // Turn off the vertical bar for this level
         MTMBar[MTMLevel] = false;
      }
   }
}

function MTMDisplayItem(item, last)
{
   var i, img, more;

   // If the item has a submenu (if it's a folder)
   if (item.submenu)
   {
      var MTMouseOverText;

      var MTMClickCmd;

      /******************************************************************
      * In MTMEmulateMVP mode we call MTMSubAction() when the +/- icon
      * of a folder has been clicked and we don't select the folder.  To
      * select the folder you click the folder icon or text and we call
      * MTMSelectAction().
      ******************************************************************/
      var MTMClickCmd2;

      var MTMDblClickCmd = false;
      var MTMfrm = "parent.frames['code']";
      var MTMref = '.menu.items[' + MTMIndices[0] + ']';

      // For nested submenus, build the fully qualified reference
      if (MTMLevel > 0)
      {
         for (i = 1; i <= MTMLevel; i++)
         {
            MTMref += ".submenu.items[" + MTMIndices[i] + "]";
         }
      }

      // if we're NOT emulating Windows Explorer or MVP, this item is NOT
      // expanded and it doesn't have a URL , pass true to MTMSubAction
      // so the menu won't be redisplayed after the click is processed.
      // I think this has something to do with tracking the right pane.
      if (!MTMEmulateMVP && !MTMEmulateWE && !item.expanded && (item.url != ""))
      {
         MTMClickCmd = "return " + MTMfrm + ".MTMSubAction(" + MTMfrm + MTMref + ",true);";
      }

      // Otherwise pass false and the menu will be redisplayed
      else
      {
         MTMClickCmd = "return " + MTMfrm + ".MTMSubAction(" + MTMfrm + MTMref + ",false);";
      }

      // If there's no URL,
      if (item.url == "")
      {
         // if we're emulating MVP and the item is inaccessible, set the mouseover
         // text to the item's text plus " - no access"
         if (MTMEmulateMVP && !item.accessible)
         {
            MTMouseOverText = (item.text.indexOf("'") != -1) ? MTMEscapeQuotes(item.text) : item.text;
            MTMouseOverText += ' - no access';
         }
         // set the mouseover text to the item's text
         else
         {
            MTMouseOverText = (item.text.indexOf("'") != -1) ? MTMEscapeQuotes(item.text) : item.text;
         }
      }

      // otherwise set it to a default value (does this ever happen?)
      else
      {
         MTMouseOverText = "Expand/Collapse";
      }
   }

   // Start the row
   MTMOutputString = '<tr valign="top"><td nowrap>\r\n';

   // Insert vertical bars or spacers at each level above this one
   if (MTMLevel > 0)
   {
      for (i = 0; i < MTMLevel; i++)
      {
         MTMOutputString += (MTMBar[i]) ? MTMakeImage("menu_bar.gif") : MTMakeImage("menu_pixel.gif");
      }
   }

   more = false;

   // If the item has a submenu (it's a folder) figure out whether or not
   // it should have a +/- icon ('more' will be set to true if so)
   if (item.submenu)
   {
      // If submenus always get a plus/minus sign or we're
      // emulating windows explorer
      if (MTMSubsGetPlus || MTMEmulateWE)
      {
         // Give the submenu a plus
         more = true;
      }
      else
      {
         // Only give the submenu a plus if it contains another submenu
         for (i = 0; i < item.submenu.items.length; i++)
         {
            if (item.submenu.items[i].submenu)
            {
               more = true;
            }
         }
      }
   }

   // If we're not giving the item a plus/minus, give it a
   // tee - or just a corner if it's the last item in the menu
   if (!more)
   {
      img = (last) ? "menu_corner.gif" : "menu_tee.gif";
   }

   // Otherwise determine the correct combination of corner/tee and plus/minus
   else
   {
      if (item.expanded)
      {
         img = (last) ? "menu_corner_minus.gif" : "menu_tee_minus.gif";
      }
      else
      {
         img = (last) ? "menu_corner_plus.gif" : "menu_tee_plus.gif";
      }

      // If there's no target url, the folder is already open,
      // we're emulating windows explorer or we're emulating MVP,
      // just give the +/- icon an onClick() and some mouseover
      // text - clicking it won't cause a target url to be displayed
      if (item.url == "" || item.expanded || MTMEmulateWE)
      {
         MTMOutputString += MTMakeVoid(item, MTMClickCmd, MTMouseOverText);
      }

      // Otherwise make the +/- icon a link to the url and also add the
      // onClick() so you can open/close it.  We don't need mouseover text
      // because the url will show up.
      else
      {
         MTMOutputString += MTMakeLink(item, true)  + ' onclick="' + MTMClickCmd + '">\r\n';
      }
   }

   // Add the plus/minus tee/corner
   MTMOutputString += MTMakeImage(img);

   // If the item has a submenu (it's a folder) ...
   if (item.submenu)
   {
      // If emulating windows explorer or MVP and the item has a url,
      // close the previous link and start a new one to wrap the
      // folder icon (but no onClick() on the folder icon itself
      // because in both modes only the +/- icons can open/close)
      if ((MTMEmulateWE || MTMEmulateMVP) && item.url != "")
      {
         MTMOutputString += '</a>\r\n' + MTMakeLink(item, false) + '>\r\n';
      }

      // Choose the folder icon based on the menu's state
      img = (item.expanded) ? "menu_folder_open.gif" : "menu_folder_closed.gif";

      // If emulating MVP...
      if (MTMEmulateMVP)
      {
         // if the item is accessible, add no link and give it an onClick()
         // that just updates which folder was clicked.
         if (item.accessible)
         {
            MTMClickCmd2 = "return " + MTMfrm + ".MTMSelectAction(" + MTMfrm + MTMref + ");";
            MTMOutputString += '</a>\r\n' + MTMakeVoid(item, MTMClickCmd2, MTMouseOverText);
         }

         // if it's inaccessible, clicking the folder icon should have no effect
         else
         {
            MTMOutputString += '</a>\r\n';
         }
      }
      else
      {
         // If this item didn't get a plus/minus icon (which means
         // we can't be in MTMEmulateWE mode) then the folder icon
         // MUST have an onClick() so it can open/close the folder
         if (!more)
         {
            // If there's no url or the item is expanded, add no link but give it
            // an onClick() and some mouseover text. (If it has no url there's no
            // need to link to it.  If it's already expanded, we don't want to
            // rewrite the target page each time you click on the folder).
            if (item.url == "" || item.expanded)
            {
               MTMOutputString += MTMakeVoid(item, MTMClickCmd, MTMouseOverText);
            }

            // Otherwise make the folder icon a link to the url and also add the
            // onClick() so you can open/close it.  We don't need mouseover text
            // because the url will show up.
            else
            {
               MTMOutputString += MTMakeLink(item, true) + ' onclick="' + MTMClickCmd + '">\r\n';
            }
         }
      }

      // Add the folder icon itself
      MTMOutputString += MTMakeImage(img);
   }

   // Otherwise it's an individual item
   else
   {
      // Make a link for the item
      MTMOutputString += MTMakeLink(item, true) + '>\r\n';

      // Use the specified item icon or look one up based on the url
      img = (item.icon != "") ? item.icon : MTMFetchIcon(item.url);

      // Add the image
      MTMOutputString += MTMakeImage(img);
   }

   // If it's a folder with a url, it's expanded and we're not in MTMEmulateWE
   // mode, then finish off the link around the folder
   // icon and start a new one for the text
   if (item.submenu && (item.url != "") && (item.expanded && !MTMEmulateWE))
   {
      MTMOutputString += '</a>\r\n' + MTMakeLink(item, false) + '>\r\n';
   }

   // If we're emulating MVP...
   if (MTMEmulateMVP)
   {
      // if the item is accessible, finish of the link for the folder icon and
      // make the item text onClick() select the item
      if (item.accessible)
      {
         MTMOutputString += '</a>\r\n' + MTMakeVoid(item, MTMClickCmd2, MTMouseOverText);
      }

      // if it's inaccessible, there won't be a link for the folder icon to
      // finish.  Use MTMakeVoid to make a link so the text is displayed
      // correctly and the mouseover works, but with no onClick().
      else
      {
         MTMOutputString += '</a>\r\n' + MTMakeVoid(item, "return true;", MTMouseOverText);
      }
   }

   // If this is Netscape Navigator 3 and we're not using a linked style sheet,
   // Add the style information inline.
   if (MTMNN3 && !MTMLinkedSS)
   {
      var stringColor;
      if (item.submenu && (item.url == "") && (item.number == MTMClickedItem))
      {
         stringColor = (item.expanded) ? MTMSubExpandColor : MTMSubClosedColor;
      }
      else if (MTMTrackedItem && MTMTrackedItem == item.number)
      {
         stringColor = MTMTrackColor;
      }
      else
      {
         stringColor = MTMLinkColor;
      }
      MTMOutputString += '<font color="' + stringColor + '" size="' + MTMenuFontSize + '" face="' + MTMenuFont + '">\r\n';
   }

   // Space over, add the item text and finish out the line.
   MTMOutputString += '&nbsp;' + item.text + ((MTMNN3 && !MTMLinkedSS) ? '</font>\r\n' : '');

   // Finish out the link around the item text
   MTMOutputString += '</a>\r\n';

   // Finish out the row
   MTMDoc.writeln(MTMOutputString + '</td></tr>');
}

function MTMEscapeQuotes(myString)
{
   var newString = "";
   var cur_pos = myString.indexOf("'");
   var prev_pos = 0;
   while (cur_pos != -1)
   {
      if (cur_pos == 0)
      {
         newString += "\\";
      }
      else if (myString.charAt(cur_pos-1) != "\\")
      {
         newString += myString.substring(prev_pos, cur_pos) + "\\";
      }
      else if (myString.charAt(cur_pos-1) == "\\")
      {
         newString += myString.substring(prev_pos, cur_pos);
      }
      prev_pos = cur_pos++;
      cur_pos = myString.indexOf("'", cur_pos);
   }
   return(newString + myString.substring(prev_pos, myString.length));
}

/******************************************************************************
* Find the menu item that corresponds to the content in the right pane, expand
* it if it's a submenu and return its index.
******************************************************************************/
function MTMTrackExpand(thisMenu)
{
   var i, targetPath;
   var foundNumber = false;
   for (i = 0; i < thisMenu.items.length; i++)
   {
      if (thisMenu.items[i].url != "" && MTMTrackTarget(thisMenu.items[i].target))
      {
         targetPath = parent.frames[thisMenu.items[i].target].location.pathname;

         if (targetPath.lastIndexOf(thisMenu.items[i].url) != -1 &&
             (targetPath.lastIndexOf(thisMenu.items[i].url) +
              thisMenu.items[i].url.length) == targetPath.length)
         {
            return(thisMenu.items[i].number);
         }
      }
      if (thisMenu.items[i].submenu)
      {
         foundNumber = MTMTrackExpand(thisMenu.items[i].submenu);
         if (foundNumber)
         {
            if (!thisMenu.items[i].expanded)
            {
               thisMenu.items[i].expanded = true;
               if (!MTMClickedItem)
               {
                  MTMClickedItem = thisMenu.items[i].number;
               }
               MTMExpansion = true;
            }
            return(foundNumber);
         }
      }
   }
   return(foundNumber);
}

/******************************************************************************
* Close all of the subfolders of MTMClickedItem (close the expanded folder
* that was clicked and all its children)
******************************************************************************/
function MTMCloseSubs(thisMenu)
{
   var i, j;
   var foundMatch = false;
   for (i = 0; i < thisMenu.items.length; i++)
   {
      if (thisMenu.items[i].submenu && thisMenu.items[i].expanded)
      {
         if (thisMenu.items[i].number == MTMClickedItem)
         {
            foundMatch = true;
            for (j = 0; j < thisMenu.items[i].submenu.items.length; j++)
            {
               if (thisMenu.items[i].submenu.items[j].expanded)
               {
                  thisMenu.items[i].submenu.items[j].expanded = false;
               }
            }
         }
         else
         {
            if (foundMatch)
            {
               thisMenu.items[i].expanded = false;
            }
            else
            {
               foundMatch = MTMCloseSubs(thisMenu.items[i].submenu);
               if (!foundMatch)
               {
                  thisMenu.items[i].expanded = false;
               }
            }
         }
      }
   }
   return(foundMatch);
}

/******************************************************************************
* Return the icon appropriate to the string passed in
******************************************************************************/
function MTMFetchIcon(testString)
{
   var i;
   for (i = 0; i < MTMIconList.items.length; i++)
   {
      if ((MTMIconList.items[i].type == 'any') && (testString.indexOf(MTMIconList.items[i].match) != -1))
      {
         return(MTMIconList.items[i].file);
      }
      else if ((MTMIconList.items[i].type == 'pre') && (testString.indexOf(MTMIconList.items[i].match) == 0))
      {
         return(MTMIconList.items[i].file);
      }
      else if ((MTMIconList.items[i].type == 'post') && (testString.indexOf(MTMIconList.items[i].match) != -1))
      {
         if ((testString.lastIndexOf(MTMIconList.items[i].match) + MTMIconList.items[i].match.length) == testString.length)
         {
            return(MTMIconList.items[i].file);
         }
      }
   }
   return("menu_link_default.gif");
}

/******************************************************************************
* Apparently this returns the row in which an object is displayed in the menu?
******************************************************************************/
function MTMGetPos(myObj)
{
   return(myObj.offsetTop + ((myObj.offsetParent) ? MTMGetPos(myObj.offsetParent) : 0));
}

/******************************************************************************
* Prepends a full path to the url if necessary
******************************************************************************/
function MTMCheckURL(myURL)
{
   var tempString = "";
   if ((myURL.indexOf("http://") == 0) || (myURL.indexOf("https://") == 0) || (myURL.indexOf("mailto:") == 0) || (myURL.indexOf("ftp://") == 0) || (myURL.indexOf("telnet:") == 0) || (myURL.indexOf("news:") == 0) || (myURL.indexOf("gopher:") == 0) || (myURL.indexOf("nntp:") == 0) || (myURL.indexOf("javascript:") == 0))
   {
      tempString += myURL;
   }
   else
   {
      tempString += MTMPreHREF + myURL;
   }
   return(tempString);
}

/******************************************************************************
* Build a link that does nothing, an onClick() and some mouseover text
******************************************************************************/
function MTMakeVoid(thisItem, thisCmd, thisText)
{
   var tempString = "";
   tempString +=  '<a name="sub' + thisItem.number + '" href="javascript:parent.frames[\'code\'].myVoid();" onclick="' + thisCmd + '" onmouseover="window.status=\'' + thisText + '\';return true;" onmouseout="window.status=\'' + window.defaultStatus + '\';return true;"';

   if (thisItem.number == MTMClickedItem)
   {
      var tempClass;
      tempClass = thisItem.expanded ? "subexpanded" : "subclosed";

      tempString += ' class="' + tempClass + '"';
   }

   // When emulating MVP, highlight this item if it's the selected one
   if (MTMEmulateMVP && MTMTrackedItem && MTMTrackedItem == thisItem.number)
   {
      tempString += ' class="tracked"';
   }

   // When emulating MVP, italicize this item if it's inaccessible
   if (MTMEmulateMVP && !thisItem.accessible)
   {
      tempString += ' class="inaccessible"';
   }

   return(tempString + '>\r\n');
}

/******************************************************************************
* Build a link (using the tracked colors if it's the link to the right pane's
* content) to a particular document.
******************************************************************************/
function MTMakeLink(thisItem, addName)
{
   var tempString = '<a';

   if (MTMTrackedItem && MTMTrackedItem == thisItem.number)
   {
      tempString += ' class="tracked"';
   }
   if (addName)
   {
      tempString += ' name="sub' + thisItem.number + '"';
   }
   tempString += ' href="' + MTMCheckURL(thisItem.url) + '"';
   if (thisItem.target != "")
   {
      tempString += ' target="' + thisItem.target + '"';
   }
   return tempString;
}

function MTMakeImage(thisImage)
{
   return('<img src="' + MTMPreHREF + MTMenuImageDirectory + thisImage + '" align="left" border="0" vspace="0" hspace="0" width="18" height="18">\r\n');
}

/******************************************************************************
* Build a transparent background image
******************************************************************************/
function MTMakeBackImage(thisImage)
{
   var tempString = 'transparent url("' + ((MTMPreHREF == "") ? "" : MTMPreHREF);
   tempString += MTMenuImageDirectory + thisImage + '")'
   return(tempString);
}

/******************************************************************************
* Build portions of a style sheet
******************************************************************************/
function MTMakeA(thisType, thisText, thisColor)
{
   var tempString = "";
   tempString += 'a' + ((thisType == "pseudo") ? ':' : '.');
   return(tempString + thisText + '{color:' + thisColor + ';background:' + MTMakeBackground() + ';}');
}

/******************************************************************************
* Build portions of a style sheet
******************************************************************************/
function MTMakeTracked()
{
   var tempString = "";

   tempString += 'a.tracked{color:' + MTMTrackColor + ';background:' + MTMTrackBackgroundColor + ';}'

   return(tempString);
}

function MTMakeInaccessible()
{
   var tempString = "";

   tempString += 'a.inaccessible{color:' + MTMTextColor + ';background:' + MTMBGColor + ';font-style:italic;}'

   return(tempString);
}

function MTMakeBackground()
{
   return((MTMBackground == "") ? MTMBGColor : 'transparent');
}

/******************************************************************************
* Return true if the specified target is what's displayed in the right pane
******************************************************************************/
function MTMTrackTarget(thisTarget)
{
   if (thisTarget.charAt(0) == "_")
   {
      return false;
   }
   else
   {
      for (i = 0; i < MTMFrameNames.length; i++)
      {
         if (thisTarget == MTMFrameNames[i])
         {
            return true;
         }
      }
   }
   return false;
}
